/**
   * Font variables are separated to different file so that the amount of font styling rules
   * doesn't overflow this one.
   * see ./marketplaceFonts.css
   * Usage example: .root { @apply --marketplaceH1FontStyles; }
   */

/* =============== Breakpoint variables ================= */
$viewportSmall: 450px;
$viewportMedium: 768px;
$viewportLarge: 1024px;
$viewportLargeWithPaddings: 1128px;
$viewportXLarge: 1921px;

/* =============== Fonts variables ================= */
@font-face {
  font-family: 'MarkPro';
  src: local('MarkPro'), url(./fonts/MarkProRegular.woff) format('woff');
}

@font-face {
  font-family: 'MarkProLight';
  src: local('MarkProLight'), url(./fonts/MarkLight.woff) format('woff');
}

@font-face {
  font-family: 'MarkProBold';
  src: local('MarkProBold'), url(./fonts/MarkProBold.woff) format('woff');
}

$fontLight: 'MarkProLight', Helvetica, Arial, sans-serif;
$fontRegular: 'MarkPro', Helvetica, Arial, sans-serif;
$fontBold: 'MarkProBold', Helvetica, Arial, sans-serif;

html {
  font-family: 'MarkPro', Helvetica, Arial, sans-serif;
}

/* Full screen Background image located in root-folder/src/assets */

/* ================ Colors ================ */
$marketplaceColor: #000000;
$marketplaceTextColor: #222222;
$marketplaceColorLight: #e2e2e2;
$marketplaceColorDark: #6f6f6e;

/* Used with inline CSS SVGs */
$marketplaceColorEncoded: 230095b3;

$successColor: #74af86;
$successColorDark: #5e8d6c;
$successColorLight: #f0fff6;
$failColor: #ff0000;
$failColorLight: #fff0f0;
$attentionColor: #e8909c;
$attentionColorLight: #fff7f0;
$attentionColorHover: #eca5af;
$bannedColorLight: var(--marketplaceColorLight);
$bannedColorDark: var(--marketplaceColor);
$ribbonColor: #81ad89;

$matterColorDark: #000000;
$matterColor: #3c3c3b;
$matterColorAnti: #9c9b9b;
$matterColorNegative: #c6c6c5;
$matterColorBright: #ececec;
$matterColorLight: #ffffff;

$matterColorLightTransparent: rgba(255, 255, 255, 0.65);

/* New UI colors.
  We need a ch story on how to structure and use them.
  2020-08-11 (Liv) */
$accentColorBlue: #9ab7dd;
$accentColorBlueHover: #adc5e3;
$accentColorGreen: #81ad89;
$accentColorGreenHover: #a0c1a6;
$brightGrey: #eaeaea;
$neutralGrey: #cfcfcf;

/* ================ Spacing unites ================ */

/* Multiples of mobile and desktop spacing units should be used with margins and paddings. */
$spacingUnit: 6px;
$spacingUnitDesktop: 8px;

/* Shadows */
$boxShadow: 0 2px 4px 0 rgba(0, 0, 0, 0.1);
$boxShadowTop: 0 -2px 4px 0 rgba(0, 0, 0, 0.1);
$boxShadowLight: 0 2px 4px 0 rgba(0, 0, 0, 0.05);
$boxShadowPopup: -1px 1px 11px rgba(0, 0, 0, 0.1);
$boxShadowPopupLight: 0 3px 6px 0 rgba(0, 0, 0, 0.2);
$boxShadowBreakdown: 0 3px 6px 0 rgba(0, 0, 0, 0.2);
$boxShadowButton: 0 4px 8px 0 rgba(0, 0, 0, 0.1);
$boxShadowListingCard: 0 0 50px 0 rgba(0, 0, 0, 0.1);
$boxShadowNotFoundPageSearch: 0 2px 4px 0 rgba(0, 0, 0, 0.5);
$boxShadowSectionLocationHover: 0 10px 30px 0 rgba(0, 0, 0, 0.1);
$boxShadowBottomForm: 0 -2px 4px 0 rgba(0, 0, 0, 0.05);
$boxShadowFilterButton: 0 4px 16px 0 rgba(0, 0, 0, 0.2);
$boxShadowInset: inset 0 0.5px 2px 0 rgba(0, 0, 0, 0.5);

/* ================ Z-index base levels ================ */

/* topbar is positioned slightly above content */
$zIndexTopbar: 10;

/* small popups on UI should use z-indexes above 50 */
$zIndexPopup: 50;

/* modals and UI overlays should use z-indexes above 100 */
$zIndexModal: 100;

/* generic error message should overlay even modals */
$zIndexGenericError: 200;

/* ================ Border radius ================ */

$borderRadius: 2px;
$borderRadiusButton: 20px;
$borderRadiusMobileSearch: 20px;
$borderRadiusPopup: 20px;

$borderRadiusHeroSearchFormMobile: 10px;
$borderRadiusHeroSearchFormDesktop: 28px;

/* ================ Transition styles ================ */

$transitionStyle: ease-in 0.2s;
$transitionStyleButton: ease-in-out 0.1s;

/* ================ Topbar heights ================ */

$topbarHeight: 60px;
$topbarHeightDesktop: 90px;

/* ================ Modal default padding ================ */

$modalPadding: 24px 24px 48px 24px;
$modalPaddingMedium: 55px 60px 55px 60px;

/* ================ LocationAutocompleteInput bottom attribution padding ================ */

/* Google Maps needs 72px bottom padding to accommodate logo, Mapbox doesn't have one */
$locationAutocompleteBottomPadding: 8px;

/* ================ Clearfix solution ================ */

/* TODO: Make a mixin */
@mixin clearfix {
  &::after {
    content: '';
    display: table;
    clear: both;
  }
}

/* ================ Links ================ */
$footerLineHeight: 1.68;

@mixin marketplaceInputStyles {
  /* Dimensions */
  display: block;
  width: 100%;
  margin: 0;
  padding: 5px 0 5px 0;
  border: none;
  border-bottom-width: 2px;
  border-bottom-style: solid;
  border-bottom-color: $marketplaceColor;
  border-radius: 0;

  &::placeholder {
    color: $matterColorAnti;
  }

  /* Effects */
  transition: border-bottom-color $transitionStyle;

  &:hover,
  &:focus {
    border-bottom-color: $matterColor;
    outline: none;
  }

  @media (min-width: $viewportMedium) {
    padding: 4px 0 10px 0;
  }
}

@mixin marketplaceLinkStyles {
  color: $marketplaceColor;
  display: inline;
  margin: 0;
  padding: 0;
  border: none;
  text-decoration: none;

  &:hover {
    text-decoration: underline;
    cursor: pointer;
  }
}

/* ================ Buttons ================ */
@mixin marketplaceButtonFontStyles {
  font-family: $fontRegular;
  font-weight: normal;
  font-size: 14px;
  line-height: normal;
  letter-spacing: normal;
}

@mixin marketplaceButtonStyles {
  @include marketplaceButtonFontStyles;

  display: block;
  min-width: 107px;
  min-height: 40px;
  margin: 0;
  padding: 20px 0 0 0;
  border: none;
  border-radius: $borderRadiusButton;
  background-color: $marketplaceColor;
  color: $matterColorLight;
  text-align: center;
  text-decoration: none;
  transition: all $transitionStyleButton;
  cursor: pointer;

  &:hover,
  &:focus {
    outline: none;
    background-color: $marketplaceColorDark;
    text-decoration: none;
    box-shadow: $boxShadowButton;
  }

  &:disabled {
    background-color: $matterColorNegative;
    color: $matterColorLight;
    cursor: not-allowed;
    box-shadow: none;
  }

  @media (min-width: $viewportMedium) {
    min-height: 40px;
  }
}

@mixin marketplaceButtonStylesSearch {
  @include marketplaceButtonStyles;

  min-width: 120px;
  max-height: 40px;
  margin: auto;
}

@mixin marketplaceButtonStylesPrimary {
  @include marketplaceButtonStyles;

  background-color: $marketplaceColor;
  color: $matterColorLight;
  min-width: 167px;

  &:hover,
  &:focus {
    background-color: $marketplaceColorDark;
  }

  &:disabled {
    background-color: $matterColorNegative;
    color: $matterColorLight;
  }
}

@mixin marketplaceButtonStylesSecondary {
  @include marketplaceButtonStyles;

  background-color: $matterColorLight;
  color: $matterColor;
  padding: 18px 0 0 0;
  border: 1px solid $matterColorNegative;

  &:hover,
  &:focus {
    background-color: $matterColorLight;
    border-color: $matterColorAnti;
  }

  &:disabled {
    background-color: $matterColorNegative;
    color: $matterColorLight;
    border-color: $matterColorNegative;
  }
}

@mixin marketplaceButtonStylesAccent {
  @include marketplaceButtonStyles;

  background-color: $attentionColor;
  color: $matterColorLigt;

  &:hover,
  &:active {
    background-color: $attentionColorHover;
  }

  &:disabled {
    background-color: $attentionColorLight;
  }
}

/* =============== Inputs ================ */
@mixin marketplaceInputStyles {
  display: block;
  width: 100%;
  margin: 0;
  padding: 5px 0 5px 0;
  border: none;
  border-bottom: 2px solid $marketplaceColor;
  border-radius: 0;
  transition: border-bottom-color var(--transitionStyle);

  &:hover,
  &:focus {
    border-bottom-color: $matterColor;
    outline: none;
  }

  @media (min-width: $viewportMedium) {
    padding: 4px 0 10px 0;
  }
}

@mixin marketplaceSelectStyles {
  display: block;
  width: 100%;
  margin: 0;
  padding: 5px 0 5px 0;
  appearance: none;
  border: none;
  border-bottom-width: 2px;
  border-bottom-style: solid;
  border-bottom-color: $marketplaceColor;
  border-radius: 0;
  background-image: url('data:image/svg+xml;utf8,<svg width="14" height="9" viewBox="0 0 14 9" xmlns="http://www.w3.org/2000/svg"><path d="M6.53 7.472c.26.26.68.26.94 0l5.335-5.333c.26-.263.26-.684 0-.944-.26-.26-.683-.26-.943 0L7 6.056l-4.862-4.86c-.26-.26-.683-.26-.943 0-.26.26-.26.68 0 .943L6.53 7.47z" stroke="%234A4A4A" fill="%234A4A4A" fill-rule="evenodd"/></svg>');
  background-size: 16px 16px;
  background-position: center right;
  cursor: pointer;
  transition: border-bottom-color $transitionStyle;

  &:disabled {
    background-image: url('data:image/svg+xml;utf8,<svg width="14" height="9" viewBox="0 0 14 9" xmlns="http://www.w3.org/2000/svg"><path d="M6.53 7.472c.26.26.68.26.94 0l5.335-5.333c.26-.263.26-.684 0-.944-.26-.26-.683-.26-.943 0L7 6.056l-4.862-4.86c-.26-.26-.683-.26-.943 0-.26.26-.26.68 0 .943L6.53 7.47z" stroke="%23E7E7E7" fill="%23E7E7E7" fill-rule="evenodd"/></svg>');
  }

  &:hover,
  &:focus {
    border-bottom-color: $matterColor;
    outline: none;
  }

  @media (min-width: $viewportMedium) {
    padding: 4px 0 10px 0;
  }
}

/* ================ Modals ================ */
@mixin marketplaceModalRootStyles {
  /* Page is using flex: AuthenticationPage's .root takes all available space */
  flex-grow: 1;
  display: flex;

  @media (min-width: $viewportMedium) {
    justify-content: center;
    align-items: flex-start;
  }
}

@mixin marketplaceModalFormRootStyles {
  display: flex;
  flex-direction: column;
  flex: 1;
  justify-content: space-between;
  height: 100%;
}

@mixin marketplaceModalBaseStyles {
  position: relative;
  display: flex;
  flex-grow: 1;
  flex-direction: column;
  padding: $modalPadding;
  background-color: $matterColorLight;
  border-radius: $borderRadius;
  border-bottom: none;

  @media (min-width: $viewportMedium) {
    flex-basis: 480px;
    flex-grow: 0;
    padding: $modalPaddingMedium;
    margin-top: 12.5vh;
    margin-bottom: 12.5vh;
  }
}

@mixin marketplaceModalInMobileBaseStyles {
  flex-grow: 1;
  position: relative;
  display: flex;
  flex-direction: column;
  height: 100vh;
  padding: 0;
  background-color: $matterColorLight;
  border-radius: $borderRadius;

  @media (min-width: $viewportMedium) {
    flex-basis: 480px;
    flex-grow: 0;
    height: 100%;
    padding: 0;
    background-color: transparent;
    border-radius: 0;
  }
}

@mixin marketplaceModalTitleStyles {
  font-size: 30px;
  line-height: 36px;
  letter-spacing: -0.5px;
  margin: 0;
  font-weight: $fontWeightBold;

  @media (min-width: $viewportMedium) {
    line-height: 40px;
    letter-spacing: -0.9px;
    margin: 0;
  }
}

@mixin marketplaceModalParagraphStyles {
  margin: 18px 0 0 0;

  @media (min-width: $viewportMedium) {
    margin: 24px 0 0 0;
  }
}

@mixin marketplaceModalBottomWrapper {
  text-align: center;
  margin-top: 60px;
  align-self: stretch;

  @media (min-width: $viewportMedium) {
    margin-top: 96px;
  }
}

@mixin marketplaceModalBottomWrapperText {
  margin-top: -24px;
  padding-bottom: 8px;

  @media (min-width: $viewportMedium) {
    padding-bottom: 0;
  }
}

@mixin marketplaceModalHelperText {
  /* @apply --marketplaceH5FontStyles; */
  color: $matterColorAnti;
  margin: 0;

  @media (min-width: $viewportMedium) {
    margin: 0;
  }
}

@mixin marketplaceModalHelperLink {
  /* @apply --marketplaceH5FontStyles; */
  color: $matterColor;
  margin: 0;

  @media (min-width: $viewportMedium) {
    margin: 0;
  }
}

@mixin marketplaceModalCloseStyles {
  position: fixed;
  top: 0;
  right: 0;
  z-index: calc($zIndexModal + 1);
  display: flex;
  align-items: flex-start;
  width: auto;
  padding: 24px;
  margin: 0;
  border: 0;
  background-color: transparent;
  color: $matterColor;
  cursor: pointer;

  @media (min-width: $viewportMedium) {
    padding: 27px 30px;
    position: absolute;
  }

  &:enabled:hover {
    background-color: transparent;
    color: $matterColorDark;
    box-shadow: none;
    text-decoration: none;
  }

  &:enabled:active {
    background-color: transparent;
    color: $matterColorDark;
  }

  &:disabled {
    background-color: transparent;
  }
}

@mixin marketplaceModalIconStyles {
  height: 48px;
  margin-bottom: 12px;

  @media (min-width: $viewportMedium) {
    height: 64px;
    margin-bottom: 23px;
  }
}

@mixin marketplaceModalCloseText {
  /* @apply --marketplaceH6FontStyles; */
  margin: -2.5px 0 0 0;

  @media (min-width: $viewportMedium) {
    margin-top: -1px;
  }
}

@mixin marketplaceModalCloseIcon {
  display: inline-block;
  margin-left: 8px;
  padding: 2px 0 4px;
  box-sizing: content-box;
}

@mixin marketplaceModalErrorStyles {
  /* @apply --marketplaceH4FontStyles; */
  margin-top: 24px;
  color: var(--failColor);
}

@mixin marketplaceModalHighlightEmail {
  font-weight: $fontWeightBold;
}

@mixin marketplaceModalPasswordMargins {
  margin-top: 24px;

  @media (min-width: $viewportMedium) {
    margin-top: 32px;
  }
}
